//*
// 屏幕共享模块
// */

import Loger from "../Loger";
import Ape from "./Ape";
import xdysdk from "libs/xdysdk";
import $ from "jquery";
import ClassDataProxy from "proxy/ClassDataProxy";
import FlashToolComponet from "libs/FlashToolComponet";
import HLSPlayer from 'tinyhls';
import UIControlApe from './UIControlApe';
import ErrorApe from './ErrorApe';
let loger = Loger.getLoger('PC-ScreenShareApe');

const FLASH_PATH = './FlashVideoPlayer.swf';//flash路径
class ScreenShareApe extends Ape {
    constructor() {
        super();
        this._isEndShare = false;//判断是否点击结束屏幕共享
        this.isLoading = false;//当前是否正在下载插件
        this.isOpenScreenShare=false;//是否已经开启屏幕共享
        this.screenFlashPlayer;
        this.h5ShareView;
        this.addEvent();
        this.isOpenScreenShare=false;
        UIControlApe.enabledLeftBar();
        UIControlApe.enabledBottomBar();
        UIControlApe.showBottomDocControlBar();
    }

    init() {
        //默认隐藏
        //屏幕共享事件
        $("#screenSharingOut").on("click", this._openScreenSharingHandler.bind(this));//开启屏幕共享
        $("#stopShare").on("click", this._closeScreenSharingHandler.bind(this));//终止共享
        //点击开启之后，为下载插件时的取消操作
        $('.downloadCancel').on("click", this._closeScreenSharingHandler.bind(this));
        //下载
        $('#download').on("click", this._downloading.bind(this));

        /*

        //点击终止共享后弹出界面->弹出界面的按钮
        $('.endShareA').on('click',this._hidePopBox.bind(this));//关闭弹出框
        $('.endShareCancel').on('click',this._hidePopBox.bind(this));//弹出框界面点击取消
        $('.endShareEnsure').on('click',this._closeScreenSharingHandler.bind(this));//弹出框界面点击确定->停止共享
        */

    }


    addEvent() {
        xdysdk.on("class_get_info_success", this._classGetInfoSuccessHandler.bind(this));//课堂数据获取成功之后就可以创建屏幕共享的flash或H5播放器
        xdysdk.on("media_stop_publish", this._mediaStopPublishHandler.bind(this));

        //屏幕共享相关
        xdysdk.on("screen_share_play", this._screenSharePlayHandler.bind(this));//收到屏幕共享播放
        xdysdk.on("screen_share_stop", this._screenShareStopHandler.bind(this));//收到屏幕共享停止
        xdysdk.on("publish_screen_share_success", this._publishScreenSuccessHandler.bind(this));//屏幕共享流发布成
        xdysdk.on("publish_screen_share_faile", this._publishScreenFailedHandler.bind(this));//屏幕共享流发布失败
        xdysdk.on("publish_screen_share_disconnect", this._screenShareConnectedHandler.bind(this));//屏幕共享服务器没有连接
        xdysdk.on("publish_screen_share_connected", this._screenShareDisconnectedHandler.bind(this));//获取屏幕共享服务器已经连接
    }
    //鼠标点击事件-------------------
    //屏幕共享
    _openScreenSharingHandler(){
        this._showScreenShareBox()
        UIControlApe.disEnabledLeftBar();
        UIControlApe.disEnabledBottomBar();
        UIControlApe.hideBottomDocControlBar();
        //调用sdk打开屏幕共享
        this._startOpenScreenShare();
        this._emit(ScreenShareApe.SCENE_SCREEN_SHARE_CHANGE,ClassDataProxy.SCENE_SCREEN_SHARE);
    }
    _onClickStopShareHandler(){
        loger.log('点击终止共享')
        //$('.screenSharingGroup').hide();
        //$('.sharingMsgBox').hide();
        this.isLoading = false
        this._showPopBox();
    }
    //在下载界面点击取消
    _closeScreenSharingHandler(){
        this.isLoading = false
        this._hidePopBox();
       // $('.screenSharingGroup').hide();
        this._hideScreenShareBox();
        this._stopScreenShare();
        this.isOpenScreenShare=false;
        UIControlApe.enabledLeftBar();
        UIControlApe.enabledBottomBar();
        UIControlApe.showBottomDocControlBar();

    }
    //在已经共享的过程中点击停止共享
    _closeSharingHandler(){
        console.log('在已经共享的过程中点击停止共享')
        this._showPopBox();
    }
    //下载插件
    _downloading(){
        this.isLoading = true;
        this._showLoadingShareTool();
        window.location.href =ClassDataProxy.ssTunnelAppURL;// 'http://baseh5.dev.3mang.com:90/Setup/0503/Xuedianyun.exe';
    }


    //事件监听-----------
    //停止当前的所有推流
    _mediaStopPublishHandler(){
        this.isLoading = false
        if(ClassDataProxy.userRole==ClassDataProxy.USER_HOST){
            loger.log('停止当前的所有推流->');
            this._stopScreenShare();
            this.isOpenScreenShare=false;
            UIControlApe.enabledLeftBar();
            UIControlApe.enabledBottomBar();
            UIControlApe.showBottomDocControlBar();
        }
        this._hideScreenShareBox();
    }

    _classGetInfoSuccessHandler(_data) {
        this.init();
        console.log('_classGetInfoSuccessHandler');
        if(_data&&_data.userRole!=ClassDataProxy.USER_HOST){
            $('.sharingMsgBox').hide();
            if (ClassDataProxy.isRecordPlayBack) {
                loger.log('屏幕共享录制回放->创建h5播放器');
                //创建h5播放器
                $('.h5ScreenShareBox').show();
                this.h5ShareView= new HLSPlayer(document.getElementById('h5ScreenShare'));
                this.h5ShareView.divName='h5ScreenShare';
                $("#h5ScreenShare")[0].poster = "";//不需要背景图片
            }else {
                //创建flash播放器
                loger.log('屏幕共享->创建flash播放器');
                $('.screenMediaShareBox').show();
                this.creatFlashPlayer();
            }
        }else {
            loger.log('屏幕共享不需要创建播放器->');
        }
    }

    //创建flash 播放器
    creatFlashPlayer() {
     /*   this.screenFlashPlayer= new FlashToolComponet();
        this.screenFlashPlayer.init({
            swfUrl: './FlashVideoPlayer.swf',
            divName: 'screenMediaShare',
            mediaId: 0,
            type: FlashToolComponet.VIDEO,//audio 或video
            callBack: this._mediaPlayerCallback.bind(this),
            videoImage: '',
            audioImage:''
        });*/

        this.screenFlashPlayer = new FlashToolComponet();
        this.screenFlashPlayer.leftGap =0;
        this.screenFlashPlayer.topGap =0;

        this.screenFlashPlayer.init({
            swfUrl: FLASH_PATH,
            divName: "screenMediaShare",
            mediaId: 0,
            layoutType: FlashToolComponet.LAYOUT_V,
            type: FlashToolComponet.SCREEN_SHARE,
            callBack: this._mediaPlayerCallback.bind(this),
            playersDataList: [
                {
                    mediaType: FlashToolComponet.SCREEN_SHARE,
                    autoScale:true,
                    width: 320,
                    height:240,
                    showFullBtn: true,
                    showPublishBtn: false,
                    showUserName:false,
                    level: 1
                }
            ],
            videoImage: '',
            audioImage: '',
            audioBtnImage: '',
            videoBtnImage: '',
            stopPublishImage: '',
            backgroundColor: 0x353536
        });
    }
    _mediaPlayerCallback(_data){
        loger.log("屏幕共享播放器监听返回->",_data);
    }
    _screenSharePlayHandler(_data){
        if(ClassDataProxy.userRole==ClassDataProxy.USER_HOST){
            loger.log('收到屏幕共享播放->老师不需要播放');
            return;
        }

        this._showScreenShareBox();
        UIControlApe.disEnabledLeftBar();
        UIControlApe.disEnabledBottomBar();
        UIControlApe.hideBottomDocControlBar();
        if (ClassDataProxy.isRecordPlayBack) {
            let seek = parseInt(_data.seek);
            if (seek < 1) {
                seek = 1;
            }

            if( this.h5ShareView){
                loger.log('收到屏幕共享播放->seek->'+seek);
                this.h5ShareView.rtmpURL=_data.replay;
                this.h5ShareView.nodeId=_data.nodeId;
                this.h5ShareView.mediaId=_data.mediaId;
                this.h5ShareView.IS_VIDEO=false;
                this.h5ShareView.play(_data.replay, HLSPlayer.MODE_VOD,seek);
            }else {
                loger.log('收到屏幕共享播放->HLS播放器不存在->');
            }

        } else {
           /* if( this.screenFlashPlayer){
                loger.log('flash->收到屏幕共享播放->',_data);
                this.screenFlashPlayer.playMedia({
                    rtmpUrl:_data.rtmpUrl,
                    mediaId:_data.mediaId,
                    mediaType:FlashToolComponet.VIDEO,
                    nodeId:_data.fromNodeId,
                    userRole:_data.userRole,
                    screenWidth:_data.screenWidth,
                    screenHeight:_data.screenHeight,
                    showFullBtn:true
                });
            }else {
                loger.log('收到屏幕共享播放->flash播放器不存在');
            }
          */
          this.playMedia({
            rtmpUrl: _data.rtmpUrl,
            mediaId: _data.mediaId,
            mediaType: FlashToolComponet.SCREEN_SHARE,
            nodeId: _data.fromNodeId,
            userRole: _data.userRole,
            userName: _data.userName,
            showFullBtn: true,
            screenWidth:_data.screenWidth||0,
            screenHeight:_data.screenHeight||0
          });
        }

    }
  //播放音视频
  playMedia(_data) {
    if (!_data) {
      loger.warn('playMedia->参数错误--->', _data);
      return;
    }
    if (this.screenFlashPlayer) {
      this.screenFlashPlayer.playMedia(_data);
    } else {
      loger.log('playMedia->没有找到对应的播放器');
    }
  }

  //停止音视频
  stopMedia(_data) {
    if (!_data) {
      loger.warn('stopMedia->参数错误', _data);
      return;
    }
    if (this.screenFlashPlayer) {
      this.screenFlashPlayer.stopFlashPlay(_data);
    } else {
      loger.log('stopMedia->没有找到对应的播放器');
    }
  }

    _screenShareStopHandler(_data){
        this.isLoading = false;
        if(ClassDataProxy.userRole==ClassDataProxy.USER_HOST){
            loger.log('收到屏幕共享停止->老师不需停止');
            return;
        }
        loger.log('收到屏幕共享停止');
        if (ClassDataProxy.isRecordPlayBack) {
            if( this.h5ShareView){
                this.h5ShareView.rtmpURL='';
                this.h5ShareView.nodeId=0;
                this.h5ShareView.mediaId=0;
                this.h5ShareView.stop();
            }

        } else {
           /* if(this.screenFlashPlayer){
                this.screenFlashPlayer.stopMedia({
                    mediaId:_data.mediaId,
                    mediaType:FlashToolComponet.SCREEN_SHARE,
                    nodeId:_data.fromNodeId,
                    userRole:_data.userRole
                });
            }*/
          this.stopMedia({
            mediaId: _data.mediaId,
            mediaType: FlashToolComponet.SCREEN_SHARE,
            nodeId: _data.fromNodeId,
            userRole: _data.userRole
          });
        }
        this._hideScreenShareBox();
        UIControlApe.enabledLeftBar();
        UIControlApe.enabledBottomBar();
        UIControlApe.showBottomDocControlBar();
    }

    _publishScreenSuccessHandler(_dara){
        if(ClassDataProxy.userRole!=ClassDataProxy.USER_HOST){
            loger.log('屏幕共享流发布成->学生不需操作');
            return;
        }
        loger.log('屏幕共享流发布成');
        this.isOpenScreenShare=true;
        UIControlApe.disEnabledLeftBar();
        UIControlApe.disEnabledBottomBar();
        UIControlApe.hideBottomDocControlBar();
        this._showStopShareBtn();
        this._emit(ScreenShareApe.SCENE_SCREEN_SHARE_CHANGE,ClassDataProxy.SCENE_SCREEN_SHARE);
    }
    _publishScreenFailedHandler(_dara){
        if(ClassDataProxy.userRole!=ClassDataProxy.USER_HOST){
            loger.log('屏幕共享流发布失败->学生不需操作');
            return;
        }
        loger.log('屏幕共享流发布失败->关闭共享界面');
        this.isOpenScreenShare=false;
        this.isLoading = false;
        this._hideScreenShareBox();
        UIControlApe.enabledLeftBar();
        UIControlApe.enabledBottomBar();
        UIControlApe.showBottomDocControlBar();
    }
    _screenShareConnectedHandler(_dara){
        if(ClassDataProxy.userRole!=ClassDataProxy.USER_HOST){
            loger.log('屏幕共享服务器没有连接->学生不需操作');
            return;
        }
        loger.log('屏幕共享服务器没有连接');
        //UIControlApe.enabledLeftBar();
        //UIControlApe.enabledBottomBar();
        //UIControlApe.showBottomDocControlBar();
        if(!this.isLoading){
            this._showLoadShareTool();
        }
        if(this.isOpenScreenShare){
            this._stopScreenShare();
        }
        this.isOpenScreenShare=false;
    }
    _screenShareDisconnectedHandler(_dara){
        if(ClassDataProxy.userRole!=ClassDataProxy.USER_HOST){
            loger.log('获取屏幕共享服务器已经连接->学生不需操作');
            return;
        }
        loger.log('获取屏幕共享服务器已经连接');
        this._showLoadingShareTool();
    }

    //----------方法调用---------

    //调用SDK打开共享
    _startOpenScreenShare(){
        loger.log('调用SDK打开共享');
        let result = xdysdk.api("publishScreenShare", {"type": "flash"});
    }
    //调用SDK停止共享
    _stopScreenShare(){
        loger.log('调用SDK停止共享');
        if(ClassDataProxy.userRole!=ClassDataProxy.USER_HOST){
            loger.log('调用SDK停止共享->学生不需操作');
            return;
        }
        if(this.isOpenScreenShare){
            this.isOpenScreenShare=false;
            let result = xdysdk.api("stopPublishScreenShare");
        }
        this.isOpenScreenShare=false;
    }

    _showScreenShareBox(){
        $(".screenSharingGroup").show();
        $(".screenSharingGroup").css("z-index",501);
        $("#screenSharingOut").addClass('active')
    }
    _hideScreenShareBox(){
        $(".screenSharingGroup").css("z-index",-6);
        $("#screenSharingOut").removeClass('active')
    }
    //点击停止共享时的弹出确认框
    _showPopBox() {
        loger.log('点击停止共享时的弹出确认框')
        $('.endShareBox').show();
        $(".masker").show();
    }
    //隐藏弹出确认框
    _hidePopBox() {
        $('.endShareBox').hide();
        $(".masker").hide();
    }

    //显示插件下载界面的1
    _showLoadShareTool(){
        $('#download').show();
        $('.downloadCancel').show();
        $('#opening').hide();
        $('#downloading').hide();
        $('#stopShare').hide();
        $('.sharingMsgBox').addClass('sharingMsgBox1');
        $('.shareBackdrop').hide();
    }
    //正在下载插件中2
    _showLoadingShareTool(){
        $('#download').hide();
        $('#opening').hide();
        $('#downloading').show();
        $('.downloadCancel').show();
        $('#stopShare').hide();
        $('.sharingMsgBox').addClass('sharingMsgBox1');
        $('.shareBackdrop').hide();
    }

    //显示屏幕共享过程中的界面->终止共享的按钮2
    _showStopShareBtn(){
        $('#download').hide();
        $('#opening').hide();
        $('#downloading').hide();
        $('#stopShare').show();
        $('.downloadCancel').hide();
        $('.sharingMsgBox').removeClass('sharingMsgBox1');
        $('.shareBackdrop').show();
    }
    //停止并且隐藏
    stopAndHide(){
        //与点击取消做同样操作
        this._closeScreenSharingHandler()
    }
    clear() {
        loger.log("clear");
        try {
            if(this.h5ShareView){
                this.h5ShareView.rtmpURL='';
                this.h5ShareView.mediaId=0;
                this.h5ShareView.nodeId=0;
                this.h5ShareView.stop()
            }
            this._hideScreenShareBox();
        } catch (err) {
            loger.warn("clear", err.message);
        }
    }

    play() {
        loger.log("play");
        try {
            if(this.h5ShareView){
                this.h5ShareView.resume()
            }
        } catch (err) {
            loger.warn("clear", err.message);
        }

    }

    pause() {
        loger.log("pause");
        try {
            if(this.h5ShareView){
                this.h5ShareView.pause()
            }
        } catch (err) {
            loger.warn("clear", err.message);
        }

    }

    stop() {
        loger.log("stop");
        try {
            if(this.h5ShareView){
                this.h5ShareView.rtmpURL='';
                this.h5ShareView.mediaId=0;
                this.h5ShareView.nodeId=0;
                this.h5ShareView.stop()
            }
            this._hideScreenShareBox();
        } catch (err) {
            loger.warn("clear", err.message);
        }

    }
}
ScreenShareApe.prototype.SCENE_SCREEN_SHARE_CHANGE = ScreenShareApe.SCENE_SCREEN_SHARE_CHANGE = "scene_screen_share_change";
export default ScreenShareApe;


