//*
// 控制UI界面的模块
// */

import Loger from "../Loger";
import Ape from "./Ape";
import xdysdk from "libs/xdysdk";
import $ from "jquery";
import ClassDataProxy from "proxy/ClassDataProxy";
let loger = Loger.getLoger('PC-UIControlApe');

class UIControlApe extends Ape {
    constructor() {
        super();
        this.showLoadingFull=true;//完整显示加载进度
        this.init();
    }
    init(){
        //关闭上传文档动画
        $('.spinnerMasker').on('mouseenter',this._showExitSpinnerMasker.bind(this));
        $('.spinnerMasker').on('mouseleave',this._hideExitSpinnerMasker.bind(this));
        $('.exitSpinnerMaskerA').on('click',this._exitSpinner.bind(this));
    }
    //设置左侧栏不可点击
    enabledLeftBar(){
        $('#leftBarEnabledMask').hide();
    }
    //设置左侧栏可点击
    disEnabledLeftBar(){
        $('#leftBarEnabledMask').show();
    }
    //设置底部栏不可点击
    enabledBottomBar(){
        $('#bottomBarEnabledMask').hide();
    }
    //设置底部栏可点击
    disEnabledBottomBar(){
        $('#bottomBarEnabledMask').show();
    }
    //显示底部栏
    showBottomDocControlBar(){;
        $('#docControlBar').show();
    }
    //隐藏底部栏
    hideBottomDocControlBar(){
        $('#docControlBar').hide();
    }
    //设置doc上传不可点击
    enabledDocBar(){
        //默认色 input按钮可点
        $('#docFileBtn').attr('disabled',false)
        $('.mediaFileContentMenuSpan').css('background','#3A9AD9')
    }
    //设置doc上传可点击
    disEnabledDocBar(){
        //灰色 input按钮不可点
        $('#docFileBtn').attr('disabled',true)
        $('.mediaFileContentMenuSpan').css('background','#9aa5ad')
    }
    //设置media上传不可点击
    enabledMediaBar(){
        //默认色 input按钮可点
        $('#mediaFileBtn').attr('disabled',false)
        $('.mediaFileContentMenuSpan').css('background','#3A9AD9')
    }
    //设置media上传可点击
    disEnabledMediaBar(){
        //灰色 input按钮不可点
        $('#mediaFileBtn').attr('disabled',true)
        $('.mediaFileContentMenuSpan').css('background','#9aa5ad')
    }
    //设置music上传不可点击
    enabledMusicBar(){
        //默认色 input按钮可点
        $('#musicFileBtn').attr('disabled',false)
        $('.mediaFileContentMenuSpan').css('background','#3A9AD9')
    }
    //设置music上传可点击
    disEnabledMusicBar(){
        //灰色 input按钮不可点
        $('#musicFileBtn').attr('disabled',true)
        $('.mediaFileContentMenuSpan').css('background','#9aa5ad')
    }


    //--------------------文件上传进度控制---------------------
    //显示文件上传的的loadin 上传文件通用的加载进度
    showLoadingMask(_isFull=true){
        $('.spinnerMasker').show();
        this.showLoadingFull=Boolean(_isFull);
        if( this.showLoadingFull==true){
            //全部显示
            this._defaultShow();
        }else{
            //最小化
            this._minimizeShow();
        }
    }
    //隐藏上传进度
    hideLoadingMask(){
        $('.spinnerMasker').hide();
        $('.minspinner').css('width','0%');
        $('.spinnerHtml').html('');
    }
    //更新上传进度百分几0-100
    updataLoadingMaskProgress(_progress){
        $('.spinnerHtml').html('loading ' + _progress +"%" );
        $('.minspinner').css('width',_progress+'%');
    }
    _exitSpinner(){
        this.showLoadingMask(!this.showLoadingFull);
    }
    _showExitSpinnerMasker(){
        $('.exitSpinnerMasker').show();
    }
    _hideExitSpinnerMasker(){
        $('.exitSpinnerMasker').hide();
    }
    _defaultShow(){
        $('.spinnerMasker').css({
            'width':'100%',
            "height":'100%',
            "bottom":"0"
        })
        $('.spinnerMask').show();
        $('.spinner').show();
        $('.spinnerHtml').css('top','50%');
        $('.exitSpinnerMasker').css('top','39%');
    }
    _minimizeShow(){
        let spinnerMasker = $('.spinnerMasker');
        spinnerMasker.css({
            'width':'300px',
            "height":'42px',
            "bottom": - $('.botTurn').height()
        })
        $('.spinnerMask').hide();
        $('.spinner').hide();
        $('.spinnerHtml').css('top','25%')
        $('.exitSpinnerMasker').css('top','25%');
    }
    //---------------------------文件上传进度控制 end------------------------
}

export default new UIControlApe;


